#ifndef _VEBUSFR_H_
#define _VEBUSFR_H_

#define IGNORE_VLL_CODE_BIT (1 << 4) /* VeBusSysConfInfo byte 7 */

/* Message IDs for VE.Bus frames that need to be handled */
#define VEBUS_RSP               0x20
#define VEBUS_CMD               0x21
#define VEBUS_RSP_PANEL         0x40
#define VEBUS_RSP_AC_IN_CONFIG  0x41

/* The broadcast address for presence frames */
#define VEBUS_DEVICE_ADDRESS_BROADCAST 0x00000000

typedef enum{
	IDENT_REQUEST,
	IDENT_DISABLE,
	FLASH_LEDS,
	RESET_DEVICE,
	WRITE_BUS_CONFIG,
	GET_BUS_CONFIG,
	FREEZE_BUS,
	__UNUSED,
	GET_PHASE_INFO,
	PANEL_IDENT_REQUEST = 0x80
} VebusCommand;

typedef enum{
	IDENT_MULTI             = 0x01,
	BUS_CONFIG_MULTI,
	BUS_CONFIG_QUATTRO,
	BUS_CONFIG_INVERTER,
	PHASE_INFO_AC3,
	PHASE_INFO_AC2,
	PHASE_INFO_AC1,
	PHASE_INFO_AC0_1,
	PHASE_INFO_AC0_2,
	PHASE_INFO_AC0_3,
	PHASE_INFO_AC0_4,
	PHASE_INFO_DC,
	IDENT_COMPACT           = 0x11,
	IDENT_PANEL             = 0x80
} VebusPresenceResponse;


void vebusFrSetConfig(VebusDevice *dev);
void vebusFrGetConfig(VebusDevice *dev, Mk2Callback *callback);
void vebusFrSendIdentRequest(Mk2Handler handler);
void vebusFrSetIdentBehaviour(un32 uniqueNumber, veBool sendIdent, Mk2Handler* handler);

#endif	/* _VEBUSFR_H_ */
