#ifndef _VLL_H_
#define _VLL_H_


/**
 * @brief Callback when vll code read is done.
 *
 * Data is formatted according to the vsc setting section file "VLLCode" section.
 *
 * @param pBuf				pointer VLLcode buffer.
 * @param size				size of the code buffer.
 * @param result			0 if successful. -1 on error
 */
typedef void VllReadCallback(char * pBuf, un16 size, int result);


/**
 * @brief Callback when vll code write is done.
 *
 * Data is formatted according to the vsc setting section file "VLLCode" section.
 *
 * @param result			0 if successful. -1 on error
 */
typedef void VllWriteCallback(int result);

void vllRead(struct VebusDeviceS* dev, char* pVllSectionData, VllReadCallback* cb, veBool codeNotUsed);
void vllWrite(struct VebusDeviceS* dev, char* pVllSectionData, un16 size,  VllWriteCallback* cb);
veBool vllCodeCompare(char* pVllSectionData1, un16 size1, char* pVllSectionData2, un16 size2);
veBool vllCheckSupport(struct VebusDeviceS* dev);

#endif	/* _VLL_H_ */
